package io;


import graphe.*;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.File;
import java.util.StringTokenizer;
import java.io.IOException;
import java.util.NoSuchElementException;


public abstract class UnLecteurGraphe
{	
	public static UnGraphe donneGraphe(String telFichier)
	{
		BufferedReader leFluxEntree=null;
		UnGraphe leGraphe=null;
		String[] lesNomsSommets;
		
		try
		{
			String laLigneLue;
			int leNbSommets;
			leFluxEntree=new BufferedReader(new FileReader(telFichier));
			
			// Lecture du nombre de sommets dans le fichier
			laLigneLue=leFluxEntree.readLine();
			leNbSommets=Integer.parseInt(laLigneLue);
			
			leGraphe=new UnGraphe(leNbSommets);
			
			
			// Lecture des differents sommets
			laLigneLue=leFluxEntree.readLine();
			StringTokenizer leST=
				new StringTokenizer(laLigneLue, Constants.FICHIER_SEP);
			
			lesNomsSommets=new String[leNbSommets];
			for(int i=0; i<lesNomsSommets.length; i++)
			{
				lesNomsSommets[i]=leST.nextToken();
			}
			
			leGraphe.sesNomsSommets=lesNomsSommets;
			
			
			// Lecture des voisins de chaque sommet
			for(int i=0; i<lesNomsSommets.length; i++)
			{
				laLigneLue=leFluxEntree.readLine();
				leST=new StringTokenizer(laLigneLue, Constants.FICHIER_SEP);
				StringTokenizer leST2=null;
				String leSuc=null;
				
				while(leST.hasMoreTokens())
				{
					leSuc=leST.nextToken();
					leST2=new StringTokenizer(leSuc, Constants.FICHIER_SEP_ELT);
					
					// Il doit y avoir 2 elts dans la chaine leSuc (S,P)
					int lIndSommet=leGraphe.donneIndiceSommet(leST2.nextToken());
					int lePoids=Integer.parseInt(leST2.nextToken());
					leGraphe.ajouteVoisin(i, lIndSommet, lePoids);
				}
			}
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
		catch(NumberFormatException nfe)
		{
			System.out.println (
				"Une chaine de caracteres lue n'est pas convertible en entier");
		}
		catch(NoSuchElementException nsee)
		{
			System.out.println (
				"Probleme de syntaxe dans l'un des voisins");
		}
		
		return leGraphe;
	}
}